﻿<Window x:Class="TournamentSoftware.Windows.Settings.SettingsWindow"
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
        xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
        xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
        xmlns:local="clr-namespace:TournamentSoftware.Windows.Settings"
        xmlns:o="clr-namespace:TournamentSoftware.Override"
        xmlns:vm="clr-namespace:TournamentSoftware.ViewModels"
        mc:Ignorable="d"
        Closing="Window_Closing"
        Title="Настройки турнира" MinWidth="1250" MinHeight="550">

    <Window.Resources>
        <Style x:Key="EditImage" TargetType="Image">
            <Setter Property="Width" Value="20"/>
            <Setter Property="Height" Value="20"/>
            <Setter Property="Visibility" Value="Collapsed"/>
            <Setter Property="Source" Value="/Windows/Settings/BlackPencil.png"/>
            <Style.Triggers>
                <DataTrigger Binding="{Binding DataContext.IsChanged, RelativeSource={RelativeSource Mode=FindAncestor, AncestorType=TabItem}}" Value="True">
                    <Setter Property="Visibility" Value="Visible"/>
                </DataTrigger>
            </Style.Triggers>
        </Style>

        <Style x:Key="TabControlStyle" TargetType="{x:Type TabControl}">
            <Setter Property="SnapsToDevicePixels" Value="True" />
            <Setter Property="Template">
                <Setter.Value>
                    <ControlTemplate TargetType="{x:Type TabControl}">
                        <Grid>
                            <Grid.RowDefinitions>
                                <RowDefinition Height="Auto" />
                                <RowDefinition Height="*" />
                            </Grid.RowDefinitions>

                            <Border>
                                <o:UniformTabPanel x:Name="HeaderPanel"/>
                            </Border>

                            <Border x:Name="Border" Grid.Row="1"
                                    BorderThickness="{TemplateBinding BorderThickness}"
                                    Background="{TemplateBinding Background}"
                                    BorderBrush="{TemplateBinding BorderBrush}">
                                <ContentPresenter x:Name="PART_SelectedContentHost" ContentSource="SelectedContent" />
                            </Border>
                        </Grid>
                    </ControlTemplate>
                </Setter.Value>
            </Setter>
        </Style>
    </Window.Resources>
    
    <Grid>

        <Grid.ColumnDefinitions>
            <ColumnDefinition />
            <ColumnDefinition Width="220"/>
        </Grid.ColumnDefinitions>

        <TabControl x:Name="settingsElementTabControl"
                Grid.Column="0"
                FontFamily="Inter"
                FontSize="20"
                Style="{StaticResource TabControlStyle}"
                SelectionChanged="settingsElementTabControl_SelectionChanged"
                Background="#F5F1DA">

            <TabItem Header="Номинации">

                <TabItem.DataContext>
                    <vm:NominationViewModel/>
                </TabItem.DataContext>

                <o:EditableDataGrid ItemsSource="{Binding Items}"
                        ColumnHeaderStyle="{StaticResource DataGridColumnHeaderStyle}"
                        CellStyle="{StaticResource DataGridCellStyle}">

                    <o:EditableDataGrid.Columns>

                        <DataGridCheckBoxColumn MinWidth="30"
                                HeaderTemplate="{StaticResource DataGridColumnHeaderCheckBoxTemplate}"
                                ElementStyle="{StaticResource DataGridSelectionCheckBoxStyle}"
                                EditingElementStyle="{StaticResource DataGridSelectionCheckBoxStyle}"/>

                        <DataGridTextColumn Header="Номинация" 
                                Width="*"
                                HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                                ElementStyle="{StaticResource ValidTemplateDataGridTextBlockStyle}"
                                Binding="{Binding Data.Name, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True}"
                                EditingElementStyle="{StaticResource DataGridTextBoxStyle}"/>

                        <DataGridCheckBoxColumn Header="Участвует в текущем турнире" 
                                Width="*"
                                ElementStyle="{StaticResource DataGridCheckBoxStyle}"
                                EditingElementStyle="{StaticResource DataGridCheckBoxStyle}"
                                HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                                Binding="{Binding Data.SelectedForCurrentTournament, UpdateSourceTrigger=PropertyChanged}"/>
                    </o:EditableDataGrid.Columns>

                    <o:EditableDataGrid.Style>
                        <Style TargetType="DataGrid" BasedOn="{StaticResource DataGridStyle}">
                            <Setter Property="IsEnabled" Value="True"/>
                            <Style.Triggers>
                                <DataTrigger Binding="{Binding Status}" Value="2">
                                    <Setter Property="IsEnabled" Value="False"/>
                                </DataTrigger>
                            </Style.Triggers>
                        </Style>
                    </o:EditableDataGrid.Style>
                </o:EditableDataGrid>
            </TabItem>

            <TabItem Header="Категории">

                <TabItem.DataContext>
                    <vm:CategoryViewModel/>
                </TabItem.DataContext>

                <o:EditableDataGrid ItemsSource="{Binding Items}"
                        ColumnHeaderStyle="{StaticResource DataGridColumnHeaderStyle}"
                        CellStyle="{StaticResource DataGridCellStyle}">
                    <o:EditableDataGrid.Columns>

                        <DataGridCheckBoxColumn MaxWidth="30"
                                HeaderTemplate="{StaticResource DataGridColumnHeaderCheckBoxTemplate}"
                                ElementStyle="{StaticResource DataGridSelectionCheckBoxStyle}"
                                EditingElementStyle="{StaticResource DataGridSelectionCheckBoxStyle}"/>

                        <DataGridTextColumn Header="Категория" 
                                Width="*"
                                HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                                ElementStyle="{StaticResource ValidTemplateDataGridTextBlockStyle}"
                                Binding="{Binding Data.Name, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True}"
                                EditingElementStyle="{StaticResource DataGridTextBoxStyle}"/>

                        <DataGridCheckBoxColumn Header="Участвует в текущем турнире" 
                                Width="*"
                                HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                                ElementStyle="{StaticResource DataGridCheckBoxStyle}"
                                EditingElementStyle="{StaticResource DataGridCheckBoxStyle}"
                                Binding="{Binding Data.SelectedForCurrentTournament, UpdateSourceTrigger=PropertyChanged}"/>
                    </o:EditableDataGrid.Columns>

                    <o:EditableDataGrid.Style>
                        <Style TargetType="DataGrid" BasedOn="{StaticResource DataGridStyle}">
                            <Setter Property="IsEnabled" Value="True"/>
                            <Style.Triggers>
                                <DataTrigger Binding="{Binding Status}" Value="2">
                                    <Setter Property="IsEnabled" Value="False"/>
                                </DataTrigger>
                            </Style.Triggers>
                        </Style>
                    </o:EditableDataGrid.Style>
                </o:EditableDataGrid>
            </TabItem>

            <TabItem x:Name="cityTab" 
                    Header="Город">

                <TabItem.DataContext>
                    <vm:CityViewModel/>
                </TabItem.DataContext>

                <o:EditableDataGrid ItemsSource="{Binding Items}"
                        ColumnHeaderStyle="{StaticResource DataGridColumnHeaderStyle}"
                        CellStyle="{StaticResource DataGridCellStyle}">
                    <o:EditableDataGrid.Columns>

                        <DataGridCheckBoxColumn MaxWidth="30"
                                HeaderTemplate="{StaticResource DataGridColumnHeaderCheckBoxTemplate}"
                                ElementStyle="{StaticResource DataGridSelectionCheckBoxStyle}"
                                EditingElementStyle="{StaticResource DataGridSelectionCheckBoxStyle}"/>

                        <DataGridTextColumn Header="Город" 
                                Width="*"
                                HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                                ElementStyle="{StaticResource ValidTemplateDataGridTextBlockStyle}"
                                EditingElementStyle="{StaticResource DataGridTextBoxStyle}"
                                Binding="{Binding Data.Name, ValidatesOnDataErrors=True,  UpdateSourceTrigger=PropertyChanged}"/>

                    </o:EditableDataGrid.Columns>

                    <o:EditableDataGrid.Style>
                        <Style TargetType="DataGrid" BasedOn="{StaticResource DataGridStyle}">
                            <Setter Property="IsEnabled" Value="True"/>
                            <Style.Triggers>
                                <DataTrigger Binding="{Binding Status}" Value="2">
                                    <Setter Property="IsEnabled" Value="False"/>
                                </DataTrigger>
                            </Style.Triggers>
                        </Style>
                    </o:EditableDataGrid.Style>
                </o:EditableDataGrid>
            </TabItem>

            <TabItem Header="Клубы">

                <TabItem.DataContext>
                    <vm:ClubViewModel/>
                </TabItem.DataContext>

                <TabItem.Resources>
                    <CollectionViewSource x:Key="Cities" Source="{Binding Cities}"/>
                </TabItem.Resources>

                <o:EditableDataGrid ItemsSource="{Binding Items}"
                        ColumnHeaderStyle="{StaticResource DataGridColumnHeaderStyle}"
                        CellStyle="{StaticResource DataGridCellStyle}">

                    <o:EditableDataGrid.Columns>

                        <DataGridCheckBoxColumn MaxWidth="30"
                                HeaderTemplate="{StaticResource DataGridColumnHeaderCheckBoxTemplate}"
                                ElementStyle="{StaticResource DataGridSelectionCheckBoxStyle}"
                                EditingElementStyle="{StaticResource DataGridSelectionCheckBoxStyle}"/>

                        <DataGridTextColumn Header="Клуб" 
                                Width="*"
                                HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                                ElementStyle="{StaticResource ValidTemplateDataGridTextBlockStyle}"
                                EditingElementStyle="{StaticResource DataGridTextBoxStyle}"
                                Binding="{Binding Data.Name, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True}"/>


                        <DataGridComboBoxColumn Header="Город"
                                Width="*"
                                HeaderTemplate="{StaticResource DataGridColumnHeaderTextBlockTemplate}"
                                ElementStyle="{StaticResource DataGridComboBoxElementStyle}"
                                DisplayMemberPath="Name"
                                ItemsSource="{Binding Source={StaticResource Cities}}"
                                SelectedItemBinding="{Binding Data.City, UpdateSourceTrigger=PropertyChanged}"
                                EditingElementStyle="{StaticResource DataGridComboBoxEditingElementStyle}"/>
                    </o:EditableDataGrid.Columns>
                    <o:EditableDataGrid.Style>
                        <Style TargetType="DataGrid" BasedOn="{StaticResource DataGridStyle}">
                            <Setter Property="IsEnabled" Value="True"/>
                            <Style.Triggers>
                                <DataTrigger Binding="{Binding Status}" Value="2">
                                    <Setter Property="IsEnabled" Value="False"/>
                                </DataTrigger>
                            </Style.Triggers>
                        </Style>
                    </o:EditableDataGrid.Style>
                </o:EditableDataGrid>
            </TabItem>

            <TabControl.Resources>

                <Style TargetType="TabItem">
                    <Setter Property="HeaderTemplate">
                        <Setter.Value>
                            <DataTemplate>
                                <StackPanel Orientation="Horizontal">
                                    <Image Style="{StaticResource EditImage}"/>
                                    <Label Content="{Binding}"/>
                                </StackPanel>
                            </DataTemplate>
                        </Setter.Value>
                    </Setter>

                    <Setter Property="Template">
                        <Setter.Value>
                            <ControlTemplate TargetType="TabItem">
                                <Border BorderBrush="Black"
                                        BorderThickness="1,0">
                                    <Grid Name="Panel">
                                        <ContentPresenter VerticalAlignment="Center"
                                                HorizontalAlignment="Center"
                                                ContentSource="Header"
                                                Margin="10"/>

                                    </Grid>
                                </Border>
                                <ControlTemplate.Triggers>
                                    <Trigger Property="IsSelected" Value="True">
                                        <Setter TargetName="Panel" Property="Background" Value="#F5F1DA"/>
                                    </Trigger>
                                    <Trigger Property="IsSelected" Value="False">
                                        <Setter TargetName="Panel" Property="Background" Value="#FDAC61" />
                                    </Trigger>
                                </ControlTemplate.Triggers>
                            </ControlTemplate>
                        </Setter.Value>
                    </Setter>
                </Style>
            </TabControl.Resources>
        </TabControl>


        <DockPanel Grid.Column="1"
                   DataContext="{Binding SelectedItem.DataContext, ElementName=settingsElementTabControl}">

            <Button Content="Добавить"
                    DockPanel.Dock="Top"
                    Command="{Binding AddItemCommand}"
                    Style="{StaticResource ButtonSettingsStyle}"/>

            <Button Content="Удалить"
                    DockPanel.Dock="Top"
                    Command="{Binding RemoveItemsCommand}"
                    Style="{StaticResource ButtonSettingsStyle}"/>

            <Button Content="Сохранить"
                    DockPanel.Dock="Top"
                    Command="{Binding SaveDataCommand}"
                    Style="{StaticResource ButtonSettingsStyle}"/>

            <DockPanel.Style>
                <Style TargetType="DockPanel" BasedOn="{StaticResource PanelSettingsStyle}">
                    <Style.Triggers>
                        <DataTrigger Binding="{Binding Tournament.RegistrationCompleted}" Value="True">
                            <Setter Property="IsEnabled" Value="False"/>
                        </DataTrigger>
                    </Style.Triggers>
                </Style>
            </DockPanel.Style>
        </DockPanel>
    </Grid>
</Window>